OBMolAtomDFSIter Class Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
OBMolAtomDFSIter Class Reference

`#include <openbabel/obiter.h>`

List of all members.

## Public Member Functions
| OBMolAtomDFSIter ()
| OBMolAtomDFSIter (OBMol *mol, int StartIndex=1)
| OBMolAtomDFSIter (OBMol &mol, int StartIndex=1)
| OBMolAtomDFSIter (const OBMolAtomDFSIter &ai)
| ~OBMolAtomDFSIter ()
OBMolAtomDFSIter & | operator= (const OBMolAtomDFSIter &ai)
| operator bool () const
OBMolAtomDFSIter & | operator++ ()
OBMolAtomDFSIter | operator++ (int)
OBAtom * | operator-> () const
OBAtom & | operator* () const
OBAtom * | next ()

## Detailed Description

Iterate over all atoms in an OBMol in a depth-first search (DFS)

Since:
  version 2.1

To facilitate iteration through all atoms in a molecule, without resorting to atom indexes (which will change in the future), a variety of iterator methods are provided.

This class provides a depth-first search ordering of atoms. When one connected component is exhausted, the iterator will start at another until all atoms are visited. No guarantee is made as to the ordering of iteration through connected components.

The iterator maintains an internal stack and list of visited atoms. As such it may not be appropriate for memory-constrained situations when iterating through large molecules.

Use of this iterator has been made significantly easier by a series of macros in the obiter.h header file:

          \#define FOR_DFS_OF_MOL(a,m)     for( OBMolAtomDFSIter     a(m); a; ++a )

Here is an example:

          #include <openbabel/obiter.h>
          #include <openbabel/mol.h>

          OBMol mol;
          FOR_DFS_OF_MOL(a, mol)
          {
             // The variable a behaves like OBAtom* when used with -> and * but
             // but needs to be explicitly converted when appearing as a parameter
             // in a function call - use &*a

          }

## Constructor & Destructor Documentation

OBMolAtomDFSIter | ( |  | ) | `[inline]`

OBMolAtomDFSIter | ( | OBMol * | mol,
|  | int | StartIndex = `1`
| ) |  |

OBMolAtomDFSIter | ( | OBMol & | mol,
|  | int | StartIndex = `1`
| ) |  |

OBMolAtomDFSIter | ( | const OBMolAtomDFSIter & | ai | ) |

~OBMolAtomDFSIter | ( |  | ) | `[inline]`

## Member Function Documentation

OBMolAtomDFSIter & operator= | ( | const OBMolAtomDFSIter & | ai | ) |

operator bool | ( |  | ) | const`[inline]`

Returns:
  Whether the iterator can still advance (i.e., visit more atoms)

OBMolAtomDFSIter & operator++ | ( |  | ) |

Preincrement -- advance to the next atom in the DFS list and return.

Referenced by OBMolAtomDFSIter::operator++().

OBMolAtomDFSIter operator++ | ( | int |  | ) |

Postincrement -- return the current atom and advance to the next atom.

OBAtom* operator-> | ( |  | ) | const`[inline]`

Returns:
  a pointer to the current atom

OBAtom& operator* | ( |  | ) | const`[inline]`

Returns:
  a reference to the current atom

OBAtom* next | ( |  | ) | `[inline]`

Returns:
  NULL if at the last atom in a fragment, else the next atom

Referenced by OBMolAtomDFSIter::operator++().

The documentation for this class was generated from the following files:

- obiter.h
- obiter.cpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines